/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         SeExprparse
#define yylex           SeExprlex
#define yyerror         SeExprerror
#define yydebug         SeExprdebug
#define yynerrs         SeExprnerrs
#define yylval          SeExprlval
#define yychar          SeExprchar
#define yylloc          SeExprlloc

/* First part of user prologue.  */
#line 6 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"

#ifndef MAKEDEPEND
#include <algorithm>
#include <vector>
#include <string>
#include <stdio.h>
#include <iostream>
#endif
#include "ExprType.h"
#include "ExprNode.h"
#include "ExprParser.h"
#include "Expression.h"
#include <mutex>

/******************
 lexer declarations
 ******************/

// declarations of functions and data in ExprParser.l
int yylex();
int yypos();
extern int yy_start;
extern char* yytext;
struct yy_buffer_state;
yy_buffer_state* yy_scan_string(const char *str);
void yy_delete_buffer(yy_buffer_state*);

/*******************
 parser declarations
 *******************/

// forward declaration
static void yyerror(const char* msg);

// local data
static const char* ParseStr;    // string being parsed
static KSeExpr::ErrorCode ParseErrorCode;  // error (set from yyerror)
static std::string ParseErrorId; // string that failed parsing (set from yyerror)
static KSeExpr::ExprNode* ParseResult; // must set result here since yyparse can't return it
static const KSeExpr::Expression* Expr;// used for parenting created SeExprOp's

/* The list of nodes being built is remembered locally here.
   Eventually (if there are no syntax errors) ownership of the nodes
   will belong solely to the parse tree and the parent expression.
   However, if there is a syntax error, we must loop through this list
   and free any nodes that were allocated before the error to avoid a
   memory leak. */
static std::vector<KSeExpr::ExprNode*> ParseNodes;
inline KSeExpr::ExprNode* Remember(KSeExpr::ExprNode* n,const int startPos,const int endPos)
    { ParseNodes.push_back(n); n->setPosition(startPos,endPos); return n; }
inline void Forget(KSeExpr::ExprNode* n)
    { ParseNodes.erase(std::find(ParseNodes.begin(), ParseNodes.end(), n)); }
/* These are handy node constructors for 0-3 arguments */
#define NODE(startPos,endPos,name) Remember(new KSeExpr::Expr##name(Expr),startPos,endPos)
#define NODE1(startPos,endPos,name,a) Remember(new KSeExpr::Expr##name(Expr,a),startPos,endPos)
#define NODE2(startPos,endPos,name,a,b) Remember(new KSeExpr::Expr##name(Expr,a,b),startPos,endPos)
#define NODE3(startPos,endPos,name,a,b,c) Remember(new KSeExpr::Expr##name(Expr,a,b,c),startPos,endPos)
#define NODE4(startPos,endPos,name,a,b,c,t) Remember(new KSeExpr::Expr##name(Expr,a,b,c,t),startPos,endPos)

#line 139 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_SEEXPR_Y_TAB_H_INCLUDED
# define YY_SEEXPR_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int SeExprdebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    IF = 258,                      /* IF  */
    ELSE = 259,                    /* ELSE  */
    EXTERN = 260,                  /* EXTERN  */
    DEF = 261,                     /* DEF  */
    FLOATPOINT = 262,              /* FLOATPOINT  */
    STRING = 263,                  /* STRING  */
    NAME = 264,                    /* NAME  */
    VAR = 265,                     /* VAR  */
    STR = 266,                     /* STR  */
    NUMBER = 267,                  /* NUMBER  */
    LIFETIME_CONSTANT = 268,       /* LIFETIME_CONSTANT  */
    LIFETIME_UNIFORM = 269,        /* LIFETIME_UNIFORM  */
    LIFETIME_VARYING = 270,        /* LIFETIME_VARYING  */
    LIFETIME_ERROR = 271,          /* LIFETIME_ERROR  */
    AddEq = 272,                   /* AddEq  */
    SubEq = 273,                   /* SubEq  */
    MultEq = 274,                  /* MultEq  */
    DivEq = 275,                   /* DivEq  */
    ExpEq = 276,                   /* ExpEq  */
    ModEq = 277,                   /* ModEq  */
    ARROW = 278,                   /* ARROW  */
    OR = 279,                      /* OR  */
    AND = 280,                     /* AND  */
    EQ = 281,                      /* EQ  */
    NE = 282,                      /* NE  */
    SEEXPR_LE = 283,               /* SEEXPR_LE  */
    SEEXPR_GE = 284,               /* SEEXPR_GE  */
    UNARY = 285                    /* UNARY  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 66 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"

    KSeExpr::ExprNode* n; /* a node is returned for all non-terminals to
		      build the parse tree from the leaves up. */
    double d;      // return value for number tokens
    char* s;       /* return value for name tokens.  Note: the string
		      is allocated with strdup() in the lexer and must
		      be freed with free() */
    struct {
        KSeExpr::ExprType::Type     type;
        int                  dim;
        KSeExpr::ExprType::Lifetime lifetime;
    } t;  // return value for types
    KSeExpr::ExprType::Lifetime l; // return value for lifetime qualifiers

#line 234 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE SeExprlval;
extern YYLTYPE SeExprlloc;

int SeExprparse (void);


#endif /* !YY_SEEXPR_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IF = 3,                         /* IF  */
  YYSYMBOL_ELSE = 4,                       /* ELSE  */
  YYSYMBOL_EXTERN = 5,                     /* EXTERN  */
  YYSYMBOL_DEF = 6,                        /* DEF  */
  YYSYMBOL_FLOATPOINT = 7,                 /* FLOATPOINT  */
  YYSYMBOL_STRING = 8,                     /* STRING  */
  YYSYMBOL_NAME = 9,                       /* NAME  */
  YYSYMBOL_VAR = 10,                       /* VAR  */
  YYSYMBOL_STR = 11,                       /* STR  */
  YYSYMBOL_NUMBER = 12,                    /* NUMBER  */
  YYSYMBOL_LIFETIME_CONSTANT = 13,         /* LIFETIME_CONSTANT  */
  YYSYMBOL_LIFETIME_UNIFORM = 14,          /* LIFETIME_UNIFORM  */
  YYSYMBOL_LIFETIME_VARYING = 15,          /* LIFETIME_VARYING  */
  YYSYMBOL_LIFETIME_ERROR = 16,            /* LIFETIME_ERROR  */
  YYSYMBOL_AddEq = 17,                     /* AddEq  */
  YYSYMBOL_SubEq = 18,                     /* SubEq  */
  YYSYMBOL_MultEq = 19,                    /* MultEq  */
  YYSYMBOL_DivEq = 20,                     /* DivEq  */
  YYSYMBOL_ExpEq = 21,                     /* ExpEq  */
  YYSYMBOL_ModEq = 22,                     /* ModEq  */
  YYSYMBOL_23_ = 23,                       /* '('  */
  YYSYMBOL_24_ = 24,                       /* ')'  */
  YYSYMBOL_ARROW = 25,                     /* ARROW  */
  YYSYMBOL_26_ = 26,                       /* ':'  */
  YYSYMBOL_27_ = 27,                       /* '?'  */
  YYSYMBOL_OR = 28,                        /* OR  */
  YYSYMBOL_AND = 29,                       /* AND  */
  YYSYMBOL_EQ = 30,                        /* EQ  */
  YYSYMBOL_NE = 31,                        /* NE  */
  YYSYMBOL_32_ = 32,                       /* '<'  */
  YYSYMBOL_33_ = 33,                       /* '>'  */
  YYSYMBOL_SEEXPR_LE = 34,                 /* SEEXPR_LE  */
  YYSYMBOL_SEEXPR_GE = 35,                 /* SEEXPR_GE  */
  YYSYMBOL_36_ = 36,                       /* '+'  */
  YYSYMBOL_37_ = 37,                       /* '-'  */
  YYSYMBOL_38_ = 38,                       /* '*'  */
  YYSYMBOL_39_ = 39,                       /* '/'  */
  YYSYMBOL_40_ = 40,                       /* '%'  */
  YYSYMBOL_UNARY = 41,                     /* UNARY  */
  YYSYMBOL_42_ = 42,                       /* '!'  */
  YYSYMBOL_43_ = 43,                       /* '~'  */
  YYSYMBOL_44_ = 44,                       /* '^'  */
  YYSYMBOL_45_ = 45,                       /* '['  */
  YYSYMBOL_46_ = 46,                       /* '{'  */
  YYSYMBOL_47_ = 47,                       /* '}'  */
  YYSYMBOL_48_ = 48,                       /* ']'  */
  YYSYMBOL_49_ = 49,                       /* ','  */
  YYSYMBOL_50_ = 50,                       /* '='  */
  YYSYMBOL_51_ = 51,                       /* ';'  */
  YYSYMBOL_YYACCEPT = 52,                  /* $accept  */
  YYSYMBOL_module = 53,                    /* module  */
  YYSYMBOL_declarationList = 54,           /* declarationList  */
  YYSYMBOL_declaration = 55,               /* declaration  */
  YYSYMBOL_lifetimeOptional = 56,          /* lifetimeOptional  */
  YYSYMBOL_typeDeclare = 57,               /* typeDeclare  */
  YYSYMBOL_typeListOptional = 58,          /* typeListOptional  */
  YYSYMBOL_typeList = 59,                  /* typeList  */
  YYSYMBOL_formalTypeListOptional = 60,    /* formalTypeListOptional  */
  YYSYMBOL_formalTypeList = 61,            /* formalTypeList  */
  YYSYMBOL_block = 62,                     /* block  */
  YYSYMBOL_optassigns = 63,                /* optassigns  */
  YYSYMBOL_assigns = 64,                   /* assigns  */
  YYSYMBOL_assign = 65,                    /* assign  */
  YYSYMBOL_ifthenelse = 66,                /* ifthenelse  */
  YYSYMBOL_optelse = 67,                   /* optelse  */
  YYSYMBOL_e = 68,                         /* e  */
  YYSYMBOL_exprlist = 69,                  /* exprlist  */
  YYSYMBOL_optargs = 70,                   /* optargs  */
  YYSYMBOL_args = 71,                      /* args  */
  YYSYMBOL_arg = 72                        /* arg  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  52
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   698

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  52
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  21
/* YYNRULES -- Number of rules.  */
#define YYNRULES  84
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  187

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   285


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    42,     2,     2,     2,    40,     2,     2,
      23,    24,    38,    36,    49,    37,     2,    39,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    26,    51,
      32,    50,    33,    27,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    45,     2,    48,    44,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,     2,    47,    43,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    25,    28,
      29,    30,    31,    34,    35,    41
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   121,   121,   123,   128,   129,   135,   143,   151,   161,
     162,   163,   164,   165,   169,   172,   177,   183,   184,   188,
     192,   199,   200,   204,   209,   218,   219,   224,   225,   229,
     230,   234,   235,   236,   239,   242,   245,   248,   251,   254,
     255,   258,   261,   264,   267,   270,   276,   281,   282,   283,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   314,   320,   321,   322,   323,   327,   328,
     334,   335,   340,   341,   345
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IF", "ELSE", "EXTERN",
  "DEF", "FLOATPOINT", "STRING", "NAME", "VAR", "STR", "NUMBER",
  "LIFETIME_CONSTANT", "LIFETIME_UNIFORM", "LIFETIME_VARYING",
  "LIFETIME_ERROR", "AddEq", "SubEq", "MultEq", "DivEq", "ExpEq", "ModEq",
  "'('", "')'", "ARROW", "':'", "'?'", "OR", "AND", "EQ", "NE", "'<'",
  "'>'", "SEEXPR_LE", "SEEXPR_GE", "'+'", "'-'", "'*'", "'/'", "'%'",
  "UNARY", "'!'", "'~'", "'^'", "'['", "'{'", "'}'", "']'", "','", "'='",
  "';'", "$accept", "module", "declarationList", "declaration",
  "lifetimeOptional", "typeDeclare", "typeListOptional", "typeList",
  "formalTypeListOptional", "formalTypeList", "block", "optassigns",
  "assigns", "assign", "ifthenelse", "optelse", "e", "exprlist", "optargs",
  "args", "arg", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-76)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      67,     0,     4,    76,    24,    31,   -76,   -76,   115,   115,
     115,   115,   115,   115,    40,    67,   -76,   -76,    77,   -76,
     -76,   587,   115,    83,    78,    62,    72,    93,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,    85,   -76,   523,    61,    61,    61,    61,
     587,    68,   -76,   -76,   -76,   -76,   587,   102,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   545,   -76,   -76,   -76,   -76,   103,
     -76,   -76,    95,     4,    98,   148,   176,   201,   226,   251,
     276,   587,   105,    81,   -76,   301,   326,   351,   376,   401,
     426,   451,   476,   -76,   -76,   115,   108,   566,   623,   639,
     653,   653,   109,   109,   109,   109,   -23,   -23,    61,    61,
      61,    61,   501,    86,    87,     4,   125,   112,    90,     4,
     -76,   -76,   -76,   -76,   -76,   -76,   -76,   115,   -76,   -76,
     -76,   -76,   -76,   -76,   -76,   -76,   587,   115,   115,   -76,
      10,    78,   -76,   116,    92,   -76,    96,     4,   135,   -76,
     137,   606,   150,    31,   118,    10,   -76,   -76,     4,    77,
     153,   117,   -76,   170,   -76,   142,   -76,    77,    36,   -76,
     -76,   143,    10,   -76,   -76,   144,   -76
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     0,    75,    74,    77,    76,     0,     0,
       0,     0,     0,     0,     0,     0,     4,     3,     0,    29,
      31,    26,     0,     9,     9,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,     0,     0,     0,     0,     0,
       0,     0,     0,    75,    74,     0,    62,    63,    64,    65,
      78,     0,     1,     5,     2,    30,    25,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    10,    11,    12,    13,     0,
      14,    16,     0,    21,     0,     0,     0,     0,     0,     0,
       0,    84,     0,    81,    82,     0,     0,     0,     0,     0,
       0,     0,     0,    50,    51,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    17,     0,     0,    22,    21,
      40,    41,    42,    43,    44,    45,    72,     0,    39,    33,
      34,    35,    36,    37,    38,    32,    79,    80,     0,    52,
      27,     9,    19,     0,    18,    23,     0,     0,     0,    83,
       0,    53,     0,     0,     0,    28,    15,     6,     0,     0,
       0,     0,    73,    47,    20,     0,    24,     0,     0,    46,
       8,     0,    27,    49,     7,     0,    48
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -76,   -76,   -76,   179,   -14,    -2,   -76,   -76,    66,   -76,
     -13,    14,   -75,   -15,    19,   -76,    -4,   -76,    51,   -76,
      65
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    14,    15,    16,    80,   126,   153,   154,   127,   128,
      17,   164,    18,    19,    20,   179,    21,    51,    92,    93,
      94
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      25,    27,    54,    55,    45,    46,    47,    48,    49,    50,
      81,    23,    24,     1,    56,    69,    70,    71,    74,   162,
     163,    72,    73,    22,    85,    86,    87,    88,    89,    90,
      91,    95,    96,    97,    98,    99,   100,   101,   102,     1,
      52,    28,    29,    30,    31,    32,    33,    34,    36,    37,
      38,    39,    40,    41,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       1,    82,     2,     3,    35,   165,     4,     5,     6,     7,
       1,    42,   182,    23,    24,    26,     4,     5,     6,     7,
       8,    75,    76,    77,    78,    83,    75,    76,    77,    78,
       8,   146,    84,     9,    10,    72,    73,   165,    34,    11,
      12,   106,    13,     9,    10,   124,   104,   105,   125,    11,
      12,   129,    13,   152,    43,    44,     6,     7,    79,   136,
     137,   147,   150,    91,   155,   151,   156,   166,     8,   157,
     167,   168,   169,    91,   161,    67,    68,    69,    70,    71,
      55,     9,    10,    72,    73,   170,   175,    11,    12,   171,
      13,   172,   176,   177,   181,   173,   174,    28,    29,    30,
      31,    32,    33,    57,   178,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,   180,
     184,   186,    72,    73,    53,   158,   185,   183,   160,   130,
      35,    57,   159,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   131,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,     0,     0,     0,
       0,    57,   132,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   133,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,     0,     0,     0,
       0,    57,   134,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   135,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,     0,     0,     0,
       0,    57,   138,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   139,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,     0,     0,     0,
       0,    57,   140,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   141,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,     0,     0,     0,
       0,    57,   142,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   143,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,     0,     0,     0,
       0,    57,   144,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,     0,     0,     0,     0,    57,   145,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,     0,     0,     0,    72,    73,   103,    57,   149,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,     0,     0,     0,    72,    73,   123,
      57,     0,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,     0,     0,     0,    72,
      73,    57,   148,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,    57,     0,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,     0,     0,
       0,    72,    73,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
      72,    73,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,     0,     0,     0,    72,    73,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
       0,     0,     0,    72,    73,    63,    64,    65,    66,    67,
      68,    69,    70,    71,     0,     0,     0,    72,    73
};

static const yytype_int16 yycheck[] =
{
       2,     3,    15,    18,     8,     9,    10,    11,    12,    13,
      24,     7,     8,     3,    18,    38,    39,    40,    22,     9,
      10,    44,    45,    23,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,     3,
       0,    17,    18,    19,    20,    21,    22,    23,    17,    18,
      19,    20,    21,    22,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
       3,     9,     5,     6,    50,   150,     9,    10,    11,    12,
       3,    50,    46,     7,     8,     9,     9,    10,    11,    12,
      23,    13,    14,    15,    16,    23,    13,    14,    15,    16,
      23,   105,     9,    36,    37,    44,    45,   182,    23,    42,
      43,     9,    45,    36,    37,    12,    48,    49,    23,    42,
      43,    23,    45,   125,     9,    10,    11,    12,    45,    24,
      49,    23,    46,   137,     9,    48,    24,   151,    23,    49,
      24,    49,    46,   147,   148,    36,    37,    38,    39,    40,
     165,    36,    37,    44,    45,   157,   169,    42,    43,    24,
      45,    24,     9,    46,   177,    47,   168,    17,    18,    19,
      20,    21,    22,    25,     4,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    47,
      47,    47,    44,    45,    15,   129,   182,   178,   147,    51,
      50,    25,   137,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    25,    51,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    25,    51,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    25,    51,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    25,    51,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    25,    51,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,
      -1,    25,    51,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    25,    51,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    -1,    44,    45,    24,    25,    48,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    -1,    -1,    44,    45,    24,
      25,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    -1,    -1,    44,
      45,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    25,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    -1,
      -1,    44,    45,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      44,    45,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    -1,    -1,    44,    45,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    -1,    -1,    44,    45,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    -1,    -1,    44,    45
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     5,     6,     9,    10,    11,    12,    23,    36,
      37,    42,    43,    45,    53,    54,    55,    62,    64,    65,
      66,    68,    23,     7,     8,    57,     9,    57,    17,    18,
      19,    20,    21,    22,    23,    50,    17,    18,    19,    20,
      21,    22,    50,     9,    10,    68,    68,    68,    68,    68,
      68,    69,     0,    55,    62,    65,    68,    25,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    44,    45,    68,    13,    14,    15,    16,    45,
      56,    56,     9,    23,     9,    68,    68,    68,    68,    68,
      68,    68,    70,    71,    72,    68,    68,    68,    68,    68,
      68,    68,    68,    24,    48,    49,     9,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    24,    12,    23,    57,    60,    61,    23,
      51,    51,    51,    51,    51,    51,    24,    49,    51,    51,
      51,    51,    51,    51,    51,    51,    68,    23,    26,    48,
      46,    48,    57,    58,    59,     9,    24,    49,    60,    72,
      70,    68,     9,    10,    63,    64,    56,    24,    49,    46,
      57,    24,    24,    47,    57,    62,     9,    46,     4,    67,
      47,    62,    46,    66,    47,    63,    47
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    52,    53,    53,    54,    54,    55,    55,    55,    56,
      56,    56,    56,    56,    57,    57,    57,    58,    58,    59,
      59,    60,    60,    61,    61,    62,    62,    63,    63,    64,
      64,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    66,    67,    67,    67,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    69,    69,
      70,    70,    71,    71,    72
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     1,     2,     6,     9,     8,     0,
       1,     1,     1,     1,     2,     5,     2,     0,     1,     1,
       3,     0,     1,     2,     4,     2,     1,     0,     1,     1,
       2,     1,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     8,     0,     4,     2,
       3,     3,     4,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     4,     6,     1,     1,     1,     1,     1,     3,
       0,     1,     1,     3,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* module: declarationList block  */
#line 121 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { ParseResult = (yyvsp[-1].n); ParseResult->setPosition((yyloc).first_column, (yyloc).last_column);
                                  ParseResult->addChild((yyvsp[0].n)); }
#line 1635 "y.tab.c"
    break;

  case 3: /* module: block  */
#line 123 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { ParseResult = NODE((yyloc).first_column, (yyloc).last_column, ModuleNode);
                                  ParseResult->addChild((yyvsp[0].n)); }
#line 1642 "y.tab.c"
    break;

  case 4: /* declarationList: declaration  */
#line 128 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column, (yyloc).last_column, ModuleNode); (yyval.n)->addChild((yyvsp[0].n)); }
#line 1648 "y.tab.c"
    break;

  case 5: /* declarationList: declarationList declaration  */
#line 130 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-1].n); (yyval.n)->setPosition((yyloc).first_column, (yyloc).last_column);
                                  (yyval.n)->addChild((yyvsp[0].n)); }
#line 1655 "y.tab.c"
    break;

  case 6: /* declaration: EXTERN typeDeclare NAME '(' typeListOptional ')'  */
#line 136 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { KSeExpr::ExprType type = KSeExpr::ExprType((yyvsp[-4].t).type, (yyvsp[-4].t).dim, (yyvsp[-4].t).lifetime);
                                    KSeExpr::ExprPrototypeNode * prototype =
                                        (KSeExpr::ExprPrototypeNode*)NODE2((yyloc).first_column, (yyloc).last_column, PrototypeNode, (yyvsp[-3].s), type);
                                  prototype->addArgTypes((yyvsp[-1].n));
                                  Forget((yyvsp[-1].n));
                                  (yyval.n) = prototype;
                                  free((yyvsp[-3].s)); }
#line 1667 "y.tab.c"
    break;

  case 7: /* declaration: DEF typeDeclare NAME '(' formalTypeListOptional ')' '{' block '}'  */
#line 144 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { KSeExpr::ExprType type = KSeExpr::ExprType((yyvsp[-7].t).type, (yyvsp[-7].t).dim, (yyvsp[-7].t).lifetime);
                                  KSeExpr::ExprPrototypeNode * prototype =
                                      (KSeExpr::ExprPrototypeNode*)NODE2((yyloc).first_column, (yylsp[-3]).last_column, PrototypeNode, (yyvsp[-6].s), type);
                                  prototype->addArgs((yyvsp[-4].n));
                                  Forget((yyvsp[-4].n));
                                  (yyval.n) = NODE2((yyloc).first_column, (yyloc).last_column, LocalFunctionNode, prototype, (yyvsp[-1].n));
                                  free((yyvsp[-6].s)); }
#line 1679 "y.tab.c"
    break;

  case 8: /* declaration: DEF NAME '(' formalTypeListOptional ')' '{' block '}'  */
#line 152 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { KSeExpr::ExprPrototypeNode * prototype =
                                        (KSeExpr::ExprPrototypeNode*)NODE1((yyloc).first_column, (yylsp[-3]).last_column, PrototypeNode, (yyvsp[-6].s));
                                  prototype->addArgs((yyvsp[-4].n));
                                  Forget((yyvsp[-4].n));
                                  (yyval.n) = NODE2((yyloc).first_column, (yyloc).last_column, LocalFunctionNode, prototype, (yyvsp[-1].n));
                                  free((yyvsp[-6].s)); }
#line 1690 "y.tab.c"
    break;

  case 9: /* lifetimeOptional: %empty  */
#line 161 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.l) = KSeExpr::ExprType::ltVARYING; }
#line 1696 "y.tab.c"
    break;

  case 10: /* lifetimeOptional: LIFETIME_CONSTANT  */
#line 162 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.l) = KSeExpr::ExprType::ltCONSTANT; }
#line 1702 "y.tab.c"
    break;

  case 11: /* lifetimeOptional: LIFETIME_UNIFORM  */
#line 163 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.l) = KSeExpr::ExprType::ltUNIFORM; }
#line 1708 "y.tab.c"
    break;

  case 12: /* lifetimeOptional: LIFETIME_VARYING  */
#line 164 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.l) = KSeExpr::ExprType::ltVARYING; }
#line 1714 "y.tab.c"
    break;

  case 13: /* lifetimeOptional: LIFETIME_ERROR  */
#line 165 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.l) = KSeExpr::ExprType::ltERROR; }
#line 1720 "y.tab.c"
    break;

  case 14: /* typeDeclare: FLOATPOINT lifetimeOptional  */
#line 169 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                 {(yyval.t).type     = KSeExpr::ExprType::tFP;
                                  (yyval.t).dim      = 1;
                                  (yyval.t).lifetime = (yyvsp[0].l); }
#line 1728 "y.tab.c"
    break;

  case 15: /* typeDeclare: FLOATPOINT '[' NUMBER ']' lifetimeOptional  */
#line 173 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.t).type = ((yyvsp[-2].d) > 0 ? KSeExpr::ExprType::tFP : KSeExpr::ExprType::tERROR);
                                  //TODO: This causes an error but does not report it to user. Change this.
                                  (yyval.t).dim  = ((yyvsp[-2].d) > 0 ? (yyvsp[-2].d) : 0);
                                  (yyval.t).lifetime = (yyvsp[0].l); }
#line 1737 "y.tab.c"
    break;

  case 16: /* typeDeclare: STRING lifetimeOptional  */
#line 177 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.t).type = KSeExpr::ExprType::tSTRING;
                                  (yyval.t).dim  = 1;
                                  (yyval.t).lifetime = (yyvsp[0].l); }
#line 1745 "y.tab.c"
    break;

  case 17: /* typeListOptional: %empty  */
#line 183 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column, (yyloc).last_column, Node); }
#line 1751 "y.tab.c"
    break;

  case 18: /* typeListOptional: typeList  */
#line 184 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 1757 "y.tab.c"
    break;

  case 19: /* typeList: typeDeclare  */
#line 188 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column, (yyloc).last_column, Node);
                                  KSeExpr::ExprType type = KSeExpr::ExprType((yyvsp[0].t).type, (yyvsp[0].t).dim, (yyvsp[0].t).lifetime);
                                  KSeExpr::ExprNode* varNode = NODE2((yyloc).first_column, (yyloc).last_column, VarNode, "", type);
                                  (yyval.n)->addChild(varNode); }
#line 1766 "y.tab.c"
    break;

  case 20: /* typeList: typeList ',' typeDeclare  */
#line 192 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-2].n);
                                  KSeExpr::ExprType type = KSeExpr::ExprType((yyvsp[0].t).type, (yyvsp[0].t).dim, (yyvsp[0].t).lifetime);
                                  KSeExpr::ExprNode* varNode = NODE2((yylsp[0]).first_column, (yylsp[0]).last_column, VarNode, "", type);
                                  (yyval.n)->addChild(varNode); }
#line 1775 "y.tab.c"
    break;

  case 21: /* formalTypeListOptional: %empty  */
#line 199 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column, (yyloc).last_column, Node); }
#line 1781 "y.tab.c"
    break;

  case 22: /* formalTypeListOptional: formalTypeList  */
#line 200 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 1787 "y.tab.c"
    break;

  case 23: /* formalTypeList: typeDeclare NAME  */
#line 204 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                 { (yyval.n) = NODE((yyloc).first_column, (yyloc).last_column, Node);
                                  KSeExpr::ExprType type = KSeExpr::ExprType((yyvsp[-1].t).type, (yyvsp[-1].t).dim, (yyvsp[-1].t).lifetime);
                                  KSeExpr::ExprNode* varNode = NODE2((yyloc).first_column, (yyloc).last_column, VarNode, (yyvsp[0].s), type);
                                  (yyval.n)->addChild(varNode);
                                  free((yyvsp[0].s)); }
#line 1797 "y.tab.c"
    break;

  case 24: /* formalTypeList: formalTypeList ',' typeDeclare NAME  */
#line 210 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-3].n);
                                  KSeExpr::ExprType type = KSeExpr::ExprType((yyvsp[-1].t).type, (yyvsp[-1].t).dim, (yyvsp[-1].t).lifetime);
                                  KSeExpr::ExprNode* varNode = NODE2((yylsp[-1]).first_column, (yylsp[0]).last_column, VarNode, (yyvsp[0].s), type);
                                  (yyval.n)->addChild(varNode);
                                  free((yyvsp[0].s)); }
#line 1807 "y.tab.c"
    break;

  case 25: /* block: assigns e  */
#line 218 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,BlockNode, (yyvsp[-1].n), (yyvsp[0].n)); }
#line 1813 "y.tab.c"
    break;

  case 26: /* block: e  */
#line 219 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 1819 "y.tab.c"
    break;

  case 27: /* optassigns: %empty  */
#line 224 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column,(yyloc).last_column,Node); /* create empty node */; }
#line 1825 "y.tab.c"
    break;

  case 28: /* optassigns: assigns  */
#line 225 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 1831 "y.tab.c"
    break;

  case 29: /* assigns: assign  */
#line 229 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,Node, (yyvsp[0].n)); /* create var list */}
#line 1837 "y.tab.c"
    break;

  case 30: /* assigns: assigns assign  */
#line 230 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-1].n); (yyvsp[-1].n)->addChild((yyvsp[0].n)); /* add to list */}
#line 1843 "y.tab.c"
    break;

  case 31: /* assign: ifthenelse  */
#line 234 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 1849 "y.tab.c"
    break;

  case 32: /* assign: VAR '=' e ';'  */
#line 235 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), (yyvsp[-1].n)); free((yyvsp[-3].s)); }
#line 1855 "y.tab.c"
    break;

  case 33: /* assign: VAR AddEq e ';'  */
#line 236 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                   {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'+');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1863 "y.tab.c"
    break;

  case 34: /* assign: VAR SubEq e ';'  */
#line 239 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                   {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'-');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1871 "y.tab.c"
    break;

  case 35: /* assign: VAR MultEq e ';'  */
#line 242 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                    {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'*');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1879 "y.tab.c"
    break;

  case 36: /* assign: VAR DivEq e ';'  */
#line 245 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                   {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'/');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1887 "y.tab.c"
    break;

  case 37: /* assign: VAR ExpEq e ';'  */
#line 248 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                   {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'^');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1895 "y.tab.c"
    break;

  case 38: /* assign: VAR ModEq e ';'  */
#line 251 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                   {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'%');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1903 "y.tab.c"
    break;

  case 39: /* assign: NAME '=' e ';'  */
#line 254 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), (yyvsp[-1].n)); free((yyvsp[-3].s)); }
#line 1909 "y.tab.c"
    break;

  case 40: /* assign: NAME AddEq e ';'  */
#line 255 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                    {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'+');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1917 "y.tab.c"
    break;

  case 41: /* assign: NAME SubEq e ';'  */
#line 258 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                    {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'-');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1925 "y.tab.c"
    break;

  case 42: /* assign: NAME MultEq e ';'  */
#line 261 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                     {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'*');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1933 "y.tab.c"
    break;

  case 43: /* assign: NAME DivEq e ';'  */
#line 264 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                    {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'/');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1941 "y.tab.c"
    break;

  case 44: /* assign: NAME ExpEq e ';'  */
#line 267 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                    {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'^');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1949 "y.tab.c"
    break;

  case 45: /* assign: NAME ModEq e ';'  */
#line 270 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                    {KSeExpr::ExprNode* varNode=NODE1((yylsp[-3]).first_column,(yylsp[-3]).first_column,VarNode, (yyvsp[-3].s));
                               KSeExpr::ExprNode* opNode=NODE3((yylsp[-1]).first_column,(yylsp[-1]).first_column,BinaryOpNode,varNode,(yyvsp[-1].n),'%');
                                (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,AssignNode, (yyvsp[-3].s), opNode);free((yyvsp[-3].s));}
#line 1957 "y.tab.c"
    break;

  case 46: /* ifthenelse: IF '(' e ')' '{' optassigns '}' optelse  */
#line 277 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,IfThenElseNode, (yyvsp[-5].n), (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1963 "y.tab.c"
    break;

  case 47: /* optelse: %empty  */
#line 281 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column,(yyloc).last_column,Node); /* create empty node */ }
#line 1969 "y.tab.c"
    break;

  case 48: /* optelse: ELSE '{' optassigns '}'  */
#line 282 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-1].n); }
#line 1975 "y.tab.c"
    break;

  case 49: /* optelse: ELSE ifthenelse  */
#line 283 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 1981 "y.tab.c"
    break;

  case 50: /* e: '(' e ')'  */
#line 288 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-1].n); }
#line 1987 "y.tab.c"
    break;

  case 51: /* e: '[' exprlist ']'  */
#line 289 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { KSeExpr::ExprNode* newNode = NODE((yyloc).first_column,(yyloc).last_column,VecNode); newNode->addChildren((yyvsp[-1].n)); Forget((yyvsp[-1].n)); (yyval.n)=newNode;}
#line 1993 "y.tab.c"
    break;

  case 52: /* e: e '[' e ']'  */
#line 290 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,SubscriptNode, (yyvsp[-3].n), (yyvsp[-1].n)); }
#line 1999 "y.tab.c"
    break;

  case 53: /* e: e '?' e ':' e  */
#line 291 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CondNode, (yyvsp[-4].n), (yyvsp[-2].n), (yyvsp[0].n)); }
#line 2005 "y.tab.c"
    break;

  case 54: /* e: e OR e  */
#line 292 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareNode, (yyvsp[-2].n), (yyvsp[0].n), '|'); }
#line 2011 "y.tab.c"
    break;

  case 55: /* e: e AND e  */
#line 293 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareNode, (yyvsp[-2].n), (yyvsp[0].n), '&'); }
#line 2017 "y.tab.c"
    break;

  case 56: /* e: e EQ e  */
#line 294 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareEqNode, (yyvsp[-2].n), (yyvsp[0].n),'='); }
#line 2023 "y.tab.c"
    break;

  case 57: /* e: e NE e  */
#line 295 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareEqNode, (yyvsp[-2].n), (yyvsp[0].n),'!'); }
#line 2029 "y.tab.c"
    break;

  case 58: /* e: e '<' e  */
#line 296 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareNode, (yyvsp[-2].n), (yyvsp[0].n),'<'); }
#line 2035 "y.tab.c"
    break;

  case 59: /* e: e '>' e  */
#line 297 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareNode, (yyvsp[-2].n), (yyvsp[0].n),'>'); }
#line 2041 "y.tab.c"
    break;

  case 60: /* e: e SEEXPR_LE e  */
#line 298 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                        { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareNode, (yyvsp[-2].n), (yyvsp[0].n),'l'); }
#line 2047 "y.tab.c"
    break;

  case 61: /* e: e SEEXPR_GE e  */
#line 299 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                        { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,CompareNode, (yyvsp[-2].n), (yyvsp[0].n),'g'); }
#line 2053 "y.tab.c"
    break;

  case 62: /* e: '+' e  */
#line 300 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 2059 "y.tab.c"
    break;

  case 63: /* e: '-' e  */
#line 301 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,UnaryOpNode, (yyvsp[0].n), '-'); }
#line 2065 "y.tab.c"
    break;

  case 64: /* e: '!' e  */
#line 302 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,UnaryOpNode, (yyvsp[0].n), '!'); }
#line 2071 "y.tab.c"
    break;

  case 65: /* e: '~' e  */
#line 303 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE2((yyloc).first_column,(yyloc).last_column,UnaryOpNode, (yyvsp[0].n), '~'); }
#line 2077 "y.tab.c"
    break;

  case 66: /* e: e '+' e  */
#line 304 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,BinaryOpNode, (yyvsp[-2].n), (yyvsp[0].n), '+'); }
#line 2083 "y.tab.c"
    break;

  case 67: /* e: e '-' e  */
#line 305 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,BinaryOpNode, (yyvsp[-2].n), (yyvsp[0].n), '-'); }
#line 2089 "y.tab.c"
    break;

  case 68: /* e: e '*' e  */
#line 306 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,BinaryOpNode, (yyvsp[-2].n), (yyvsp[0].n), '*'); }
#line 2095 "y.tab.c"
    break;

  case 69: /* e: e '/' e  */
#line 307 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,BinaryOpNode, (yyvsp[-2].n), (yyvsp[0].n), '/'); }
#line 2101 "y.tab.c"
    break;

  case 70: /* e: e '%' e  */
#line 308 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,BinaryOpNode, (yyvsp[-2].n), (yyvsp[0].n), '%'); }
#line 2107 "y.tab.c"
    break;

  case 71: /* e: e '^' e  */
#line 309 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE3((yyloc).first_column,(yyloc).last_column,BinaryOpNode, (yyvsp[-2].n), (yyvsp[0].n), '^'); }
#line 2113 "y.tab.c"
    break;

  case 72: /* e: NAME '(' optargs ')'  */
#line 310 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,FuncNode, (yyvsp[-3].s));
				  free((yyvsp[-3].s)); // free name string
				  // add args directly and discard arg list node
				  (yyval.n)->addChildren((yyvsp[-1].n)); Forget((yyvsp[-1].n)); }
#line 2122 "y.tab.c"
    break;

  case 73: /* e: e ARROW NAME '(' optargs ')'  */
#line 315 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,FuncNode, (yyvsp[-3].s));
				  free((yyvsp[-3].s)); // free name string
				  (yyval.n)->addChild((yyvsp[-5].n));
				  // add args directly and discard arg list node
				  (yyval.n)->addChildren((yyvsp[-1].n)); Forget((yyvsp[-1].n)); }
#line 2132 "y.tab.c"
    break;

  case 74: /* e: VAR  */
#line 320 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,VarNode, (yyvsp[0].s)); free((yyvsp[0].s)); /* free name string */ }
#line 2138 "y.tab.c"
    break;

  case 75: /* e: NAME  */
#line 321 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,VarNode, (yyvsp[0].s)); free((yyvsp[0].s)); /* free name string */ }
#line 2144 "y.tab.c"
    break;

  case 76: /* e: NUMBER  */
#line 322 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,NumNode, (yyvsp[0].d)); /*printf("line %d",@$.last_column);*/}
#line 2150 "y.tab.c"
    break;

  case 77: /* e: STR  */
#line 323 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,StrNode, (yyvsp[0].s)); free((yyvsp[0].s)); /* free string */}
#line 2156 "y.tab.c"
    break;

  case 78: /* exprlist: e  */
#line 327 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,Node,(yyvsp[0].n)); }
#line 2162 "y.tab.c"
    break;

  case 79: /* exprlist: exprlist ',' e  */
#line 328 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-2].n);
                                  (yyvsp[-2].n)->addChild((yyvsp[0].n)); }
#line 2169 "y.tab.c"
    break;

  case 80: /* optargs: %empty  */
#line 334 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE((yyloc).first_column,(yyloc).last_column,Node); /* create empty node */}
#line 2175 "y.tab.c"
    break;

  case 81: /* optargs: args  */
#line 335 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 2181 "y.tab.c"
    break;

  case 82: /* args: arg  */
#line 340 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = NODE1((yyloc).first_column,(yyloc).last_column,Node, (yyvsp[0].n)); /* create arg list */}
#line 2187 "y.tab.c"
    break;

  case 83: /* args: args ',' arg  */
#line 341 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[-2].n); (yyvsp[-2].n)->addChild((yyvsp[0].n)); /* add to list */}
#line 2193 "y.tab.c"
    break;

  case 84: /* arg: e  */
#line 345 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"
                                { (yyval.n) = (yyvsp[0].n); }
#line 2199 "y.tab.c"
    break;


#line 2203 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 348 "/home/iurt/rpmbuild/BUILD/kseexpr-4.0.4.0-build/kseexpr-v4.0.4.0/src/KSeExpr/ExprParser.y"


      /* yyerror - Report an error.  This is called by the parser.
	 (Note: the "msg" param is useless as it is usually just "parse error".
	 so it's ignored.)
      */
static void yyerror(const char* /*msg*/)
{
    // find start of line containing error
    int pos = yypos(), lineno = 1, start = 0, end = strlen(ParseStr);

    for (int i = start; i < pos; i++)
	if (ParseStr[i] == '\n') { start = i + 1; lineno++; }

    // find end of line containing error
    for (int i = end; i > pos; i--)
	if (ParseStr[i] == '\n') { end = i - 1; }

    ParseErrorCode = yytext[0] ? KSeExpr::ErrorCode::SyntaxError : KSeExpr::ErrorCode::UnexpectedEndOfExpression;

    ParseErrorId = "";

    int s = std::max(start, pos-30);
    int e = std::min(end, pos+30);

    if (s != start) ParseErrorId += "...";
    ParseErrorId += std::string(ParseStr, s, e-s+1);
    if (e != end) ParseErrorId += "...";
}


/* CallParser - This is our entrypoint from the rest of the expr library.
   A string is passed in and a parse tree is returned.	If the tree is null,
   an error string is returned.  Any flags set during parsing are passed
   along.
 */

extern void SeExprLexerResetState(std::vector<std::pair<int,int> >& comments);

static std::mutex mutex;

namespace KSeExpr {
bool ExprParse(KSeExpr::ExprNode*& parseTree,
    KSeExpr::ErrorCode& errorCode,
    std::vector<std::string>& errorIds,
    int& errorStart,
    int& errorEnd,
    std::vector<std::pair<int,int> >& comments,
    const KSeExpr::Expression* expr,
    const char* str,
    bool)
{
    std::lock_guard<std::mutex> locker(mutex);

    // glue around crippled C interface - ugh!
    Expr = expr;
    ParseStr = str;
    SeExprLexerResetState(comments);
    yy_buffer_state* buffer = yy_scan_string(str);
    ParseResult = 0;
    int resultCode = yyparse();
    yy_delete_buffer(buffer);

    if (resultCode == 0) {
        // success
        errorCode = ErrorCode::None;
        errorIds = {};
	    parseTree = ParseResult;
    }
    else {
        // failure
        errorCode = ParseErrorCode;
        errorIds = { ParseErrorId };
        errorStart=yylloc.first_column;
        errorEnd=yylloc.last_column;
        parseTree = nullptr;

        // gather list of nodes with no parent
        std::vector<KSeExpr::ExprNode*> delnodes;
        std::vector<KSeExpr::ExprNode*>::iterator iter;
        for (iter = ParseNodes.begin(); iter != ParseNodes.end(); iter++) {
            if (!(*iter)->parent()) {
                delnodes.push_back(*iter);
            }
        }

        // now delete them (they will delete their own children)
        for (iter = delnodes.begin(); iter != delnodes.end(); iter++) {
            delete *iter;
        }
    }
    ParseNodes.clear();

    return parseTree != nullptr;
}
}
